<template>
  <div>
    <v-form>
      <v-layout row wrap>
        <v-flex md12>
          <v-layout row wrap>
            <v-flex xs6>
              <v-select
                v-model="user.roles"
                :items="rolesList"
                item-value="valueRole"
                item-text="textRole"
                box
                label="Rôle de l'utilisateur"
              ></v-select>
            </v-flex>

            <v-flex xs6>
              <v-select
                v-model="user.actif"
                :items="actifList"
                item-value="valueRole"
                item-text="textRole"
                box
                label="Statut utilisateur"
              ></v-select>
            </v-flex>

            <v-flex xs12>
              <v-text-field v-model="user.name" label="Nom" :rules="nameRules"></v-text-field>
            </v-flex>

            <v-flex xs12>
              <v-text-field v-model="user.email" label="Email" :rules="emailRules"></v-text-field>
            </v-flex>

            <v-flex xs12 v-if="action =='create' ">
              <v-text-field
                v-model="user.password"
                :type="'password'"
                label="Password"
                :rules="nameRules"
              ></v-text-field>
            </v-flex>

            <v-flex xs12>
              <v-btn block color="success" @click="submitUser()">Valider</v-btn>
            </v-flex>
          </v-layout>
        </v-flex>
      </v-layout>
    </v-form>

    <v-snackbar
      v-model="snackbar"
      :bottom="y === 'bottom'"
      :left="x === 'left'"
      :multi-line="mode === 'multi-line'"
      :right="x === 'right'"
      :timeout="timeout"
      :top="y === 'top'"
      :vertical="mode === 'vertical'"
      :color="color"
    >
      {{ text }}
      <v-btn color="white" flat @click="snackbar = false">
        <v-icon>close</v-icon>
      </v-btn>
    </v-snackbar>
  </div>
</template>

<script>
// import axios from "axios";
import { getHeader } from "@/config";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_USER = URL_API + "api/users/show/";
const URL_EDIT_USER = URL_API + "api/users/edit/";
const URL_CREATE_USER = URL_API + "api/users/create";
const SITE_ALIAS = process.env.VUE_APP_SITE_ALIAS;

export default {
  props: ["action"],
  mounted: function() {
    if (this.action === "edit") {
      this.idUser = this.$route.params.id;
      this.fetchDataUser();
    }
  },
  data() {
    return {
      // snackbar
      dialog: false,
      snackbar: false,
      y: "top",
      x: null,
      mode: "",
      timeout: 6000,
      text: "",
      color: "pink",

      validForm: false,
      idUser: "",
      user: {
        name: "",
        email: ""
      },

      // champs select
      rolesList: [
        {
          textRole: "Admin",
          valueRole: "ROLE_ADMIN"
        },
        {
          textRole: "Commercial",
          valueRole: "ROLE_COMMERCIAL"
        },
        {
          textRole: "Client",
          valueRole: "ROLE_CLIENT"
        }
      ],
      actifList: [
        {
          textRole: "Actif",
          valueRole: true
        },
        {
          textRole: "Non actif",
          valueRole: false
        }
      ],

      // rules validations form
      emailRules: [v => !!v || "E-mail is required", v => /.+@.+/.test(v) || "E-mail must be valid"],
      nameRules: [v => !!v || "Name is required"]
    };
  },
  methods: {
    fetchDataUser() {
      this.$axios
        .get(URL_USER + this.idUser, { headers: getHeader() })
        .then(response => {
          this.user = response.data.user;
        })
        .catch(error => {
          console.log("error", error);
        });
    },
    submitUser() {
      if (this.action === "edit") {
        console.log("edit user", this.user);
        this.$axios
          .put(URL_EDIT_USER + this.idUser, this.user, { headers: getHeader() })
          .then(response => {
            this.$router.push({ name: "admin-users-liste" });
          })
          .catch(error => {
            console.log("error");
          });
      } else {
        console.log("new user", this.user);
        if (this.user.email !== "" && this.user.name !== "" && this.user.password !== "") {
          this.user.sitealias = SITE_ALIAS;
          this.user.password_confirmation = this.user.password;
          this.$axios
            .post(URL_CREATE_USER, this.user, { headers: getHeader() })
            .then(response => {
              console.log(response.data);
              // send mail création utilisateur ?
              this.$router.push({ name: "admin-users-liste" });
            })
            .catch(error => {
              console.log("error");
            });
        } else {
          this.text = "Veuillez renseigner tous les champs correctement";
          this.snackbar = true;
        }
      }
    }
  }
};
</script>


